﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

using VidyaVitamin.Plugin;

namespace VidyaVitamin.Plugin.Thumbnail
{
	public partial class ProgressForm : Form
	{
		private string folder, pct_name;
		private ThumbnailData[] tdata;
		private List<int> sellist;
		private IFirebirdTable table;

		public ProgressForm(IFirebirdTable table, string pct_name, string folder,
			ThumbnailData[] tdata, List<int> sellist)
		{
			InitializeComponent();

			this.pct_name = pct_name;
			this.folder = folder;
			this.tdata = tdata;
			this.sellist = sellist;
			this.table = table;

			pgb.Maximum = sellist.Count;
		}

		protected override void OnShown(EventArgs e)
		{
			base.OnShown(e);

			w.RunWorkerAsync();
		}

		private void w_DoWork(object sender, DoWorkEventArgs e)
		{
			BackgroundWorker w = (BackgroundWorker)sender;

			int pos = 0;
			foreach (int n in sellist) {
				if (e.Cancel == true) break;
				w.ReportProgress(pos++);

				int i = tdata[n].index;
				IFbResult res = null;
				try{
					string sqlcmd = string.Format(
						"SELECT M.{0} AS RM, S.{1} AS RS FROM {2} AS M INNER JOIN {2}${0} AS S ON " +
						" M.{3} = S.{3} WHERE M.{3}={4};",
						pct_name, Thumbnail.STR_BINARY, table.TableName, Thumbnail.STR_ID, tdata[n].index);
					res = table.IFirebird.ExecCommand(sqlcmd);
					foreach(Hashtable h in res){
						File.WriteAllBytes(folder + Path.GetFileName((string)h["RM"]),
							h["RS"] as byte[]);
					}
				}finally{
					res.Close();
				}
			}
		}

		private void w_ProgressChanged(object sender, ProgressChangedEventArgs e)
		{
			pgb.Value = e.ProgressPercentage;
		}

		private void btnCancel_Click(object sender, EventArgs e)
		{
			if (w.IsBusy == true) w.CancelAsync();
		}
	}
}
